# ----------------------------------------------------------------
# ------------------------------------------------------------------------------
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
#
#  NetworkService Module:
#    Classes:
#
# ----------------------------------------------------------------
import getopt
import os
import sys
import types, exceptions
import time
import socket
import xmllib, xmlrpclib

class NetworkServiceInterface:
    def __init__(self):
        raise NotImplementedError, 'NetworkServiceInterface.__init__()'
    # ----------------------------------------------------------------
    #  *float* The buffersize in Bytes.
    # ----------------------------------------------------------------
    def getBufferSize(self, host):
        raise NotImplementedError, 'NetworkServiceInterface.getBufferSize()'

# ----------------------------------------------------------------
#  XML_EnableService(NetworkServiceInterface):
#       *ignore possibility of multiple IP's
# ----------------------------------------------------------------

class XML_EnableService(NetworkServiceInterface):
    def __init__(self, enable_host, port=8002):
        try:
            name = socket.gethostbyaddr(enable_host)
            uri = "http://%s:%d" %(name[0], port)
        except NameError, ex:
            raise RuntimeError(('Failed to resolve %s' %(enable_host)))
        except IndexError, ex:
            uri = "http://%s:%d" %(enable_host, port)
        try:
            self._server = xmlrpclib.Server(uri)
        except:
            raise RuntimeError(('Error contacting %s:%d' %(enable_host, port)))
        return
    # ----------------------------------------------------------------
    #  getBufferSize(self, hostname):
    #       *ignore possibility of multiple IP's
    # ----------------------------------------------------------------
    def getBufferSize(self, hostname):
        try:
            name = socket.gethostbyaddr(hostname)
            h    = name[2][0]
        except NameError, ex:
            raise RuntimeError(('Failed to resolve %s' %(enable_host)))
        except IndexError, ex:
            h    = hostname
        call = self._server.GetBufferSize
        try:
            kb = call(h)
        except xmlrpclib.ProtocolError, ex:
            raise RuntimeError(('Error talking to server'), str(ex))
        except xmlrpclib.Fault, ex:
            raise RuntimeError(('Error talking to server'), str(ex))
        except socket.error, ex:
            raise RuntimeError(('socket.error talking to server', ex.args))
        except Exception, ex:
            raise RuntimeError(('Error talking to server', ex.args))
        # kb = '64.00KB'
        buf_bytes = int(float(kb[:-2])*1000)
        return buf_bytes
